var max = 0;
var min = 100000;
$(document).ready(function() {
  
  var camera = new Camera3D();
  camera.init(0,0,0,300);

  //var paper = Raphael(10, 10, 500, 500);
  var c = document.getElementById('myCanvas');
  var cxt = c.getContext("2d");

  //var object3D = new Cube(paper, 100);
  var object3D = new Superformula(cxt, 100);
	
  var scene = new Scene3D();
  scene.setRotationCenter(new Point3D(c.width/2, c.height/2, 0));
  scene.addToScene(object3D);

  var time1, time2;
  var animateIt = function(){
    time1 = new Date().getTime();
    scene.setAxisRotation(scene.axisRotation.x - 0.01, scene.axisRotation.y+ 0.02);
    scene.renderCamera(camera);
    time2 = new Date().getTime();
    //$('#fps').html("SPF: "+(time2-time1)+" <br>FPS: "+Math.round(1000/(time2-time1)));
    $('#fps').html("FPS: "+Math.round(1000/(time2-time1)));
  };

  setInterval(animateIt, 40);
});

//// Point and Edge ----------------------------------------------
var Point3D = function(x,y,z){
  this.x = x;
  this.y = y;
  this.z = z;
}

var Point2D = function(_cxt, x,y, depth, scaleFactor){
  this.cxt = _cxt;
  this.x = x;
  this.y = y;
  this.depth = depth;
  this.scaleFactor = scaleFactor;
  this.circle = null;

  this.setVars = function(x, y, depth, scaleFactor){
    this.x = x;
    this.y = y;
    this.depth = depth;
    this.scaleFactor = scaleFactor;
  }
  this.draw = function(){
    //this.cxt.strokeStyle = "rgb(0, 150, 255)";
    var scale = 1-(this.scaleFactor*0.667);
//    if(scale>max){
//      max = scale
//      console.log("max", max);
//    }
//    if(scale<min){
//      min = scale
//      console.log("min", min);
//    }
    //this.cxt.strokeRect(this.x, this.y, scale, scale);
    //this.cxt.fillStyle = "rgb(100, 200, 255)";
    var test = Math.round(scale*255*2);
    this.cxt.fillStyle = "rgb("+test+", "+test+", 255)";
    //this.cxt.fillRect(this.x+2, this.y+2, scale-2, scale-2);
    this.cxt.fillRect(this.x, this.y, scale*5, scale*5);
    //this.cxt.beginPath();
    //this.cxt.arc(this.x, this.y, 1, 0, Math.PI*2, true);
    //this.cxt.fillStyle = "rgb(0, 150, 255)";
    //this.cxt.closePath();
    //this.cxt.lineWidth = 2;
    //this.cxt.strokeStyle = "rgb(0, 150, 255)";
    //this.cxt.stroke();
  };
}

var Edge = function(_cxt, point2DIdx1, point2DIdx2){
  this.point2DIdx1 = point2DIdx1;
  this.point2DIdx2 = point2DIdx2;
  this.cxt = _cxt;
  
  this.draw = function(pointsArray2D){
    var point2D1 = pointsArray2D[this.point2DIdx1];
    var point2D2 = pointsArray2D[this.point2DIdx2];

    this.cxt.beginPath();
    //this.ctx.lineTo(x, y);
    //this.cxt.arc(70,18,15,0,Math.PI*2,true);
    this.cxt.endPath();

  //    if(this.path == null){
  //      if(point2D1 && point2D2){
  //        this.path = this.paper.path(
  //          "M"+point2D1.x+
  //          ", "+point2D1.y+
  //          "L"+point2D2.x+
  //          ", "+point2D2.y);
  //      }
  //    }else{
  //      this.path.attr({
  //        path:
  //        "M"+point2D1.x+
  //        ", "+point2D1.y+
  //        "L"+point2D2.x+
  //        ", "+point2D2.y
  //      });
  //    }
  };
}

//// Object3D ----------------------------------------------
var Object3D = function(){
  this.x = 0;
  this.y = 0;
  this.z = 0;
  this.scale = 1;
  this.pointsArray3D = [];
  this.pointsArray2D = [];
  this.edgesArray = [];
  this.cxt = null;

  this.setCxt = function(_cxt){
    this.cxt = _cxt;
  };
  
  //Create 3d Points
  this.add3DPoint = function(x,y,z) {
    this.pointsArray3D.push(new Point3D(x+this.x, y+this.y, z+this.z));
  };

  //Create 2d Points
  this.add2DPoint = function(x, y, depth, scaleFactor){
    var newPoint = new Point2D(this.cxt, x, y, depth, scaleFactor);
    this.pointsArray2D.push(newPoint);
    return newPoint;
  };

  this.set2DPoint = function(idx, x,y, depth, scaleFactor){
    if(this.pointsArray2D[idx] == null){
      this.add2DPoint(x, y, depth, scaleFactor);
    }else{
      this.pointsArray2D[idx].setVars(x, y, depth, scaleFactor);
    }
  };

  this.addEdge = function(pointIdx1, pointIdx2){
    this.edgesArray.push(
      new Edge(this.cxt, pointIdx1, pointIdx2));
  };

  this.draw = function(){
    
    //this.cxt.fillStyle = "rgb(255, 255, 255)";
    this.cxt.fillStyle = "rgb(0, 0, 0)";
    this.cxt.globalAlpha = 0.01;
    //--hardcoded with and height
    this.cxt.fillRect(0, 0, 500, 500);
    this.cxt.globalAlpha = 1;
    //this.cxt.canvas.width = this.cxt.canvas.width;
    //this.cxt.canvas.height = this.cxt.canvas.height;

    for (var i = 0; i < this.pointsArray2D.length; i++) {
      var point = this.pointsArray2D[i];
      point.draw();
    }
    for (i = 0; i < this.edgesArray.length; i++) {
      var edge = this.edgesArray[i];
      edge.draw(this.pointsArray2D)
    }
  };
};


//// Camera3D ----------------------------------------------
var Camera3D = function (){
  this.x = 0;
  this.y = 0;
  this.z = 500;
  this.focalLength = 1000;

  this.init = function (x,y,z,focalLength){
    this.x = x;
    this.y = y;
    this.z = z;
    this.focalLength = focalLength;
  };

  this.scaleRatio = function(item){
    return this.focalLength/(this.focalLength + item.z - this.z);
  };

};

//// Scene3D ----------------------------------------------
var Scene3D = function (){
  this.sceneItems = [];
  this.axisRotation = new Point3D(0, 0, 0);
  this.rotationCenter = new Point3D(0, 0, 0);
  this.sx = Math.sin(this.axisRotation.x);
  this.cx = Math.cos(this.axisRotation.x);
  this.sy = Math.sin(this.axisRotation.y);
  this.cy = Math.cos(this.axisRotation.y);
  this.sz = Math.sin(this.axisRotation.z);
  this.cz = Math.cos(this.axisRotation.z);

  this.addToScene = function (object3D){
    this.sceneItems.push(object3D);
  };

  this.setRotationCenter = function(newCenterPoint3D){
    this.rotationCenter = newCenterPoint3D;
  };

  this.setAxisRotation = function(newRotationX, newRotationY){
    this.axisRotation.x = newRotationX;
    this.axisRotation.y = newRotationY;
    this.sx = Math.sin(this.axisRotation.x);
    this.cx = Math.cos(this.axisRotation.x);
    this.sy = Math.sin(this.axisRotation.y);
    this.cy = Math.cos(this.axisRotation.y);
    this.sz = Math.sin(this.axisRotation.z);
    this.cz = Math.cos(this.axisRotation.z);
  }

  this.Transform3DPointsTo2DPoints = function(obj, camera){
    var points = obj.pointsArray3D;
    var x,y,z, xy,xz, yx,yz, zx,zy, scaleFactor;
    var i = points.length;
    while (i--){

      x = points[i].x-this.rotationCenter.x;
      y = points[i].y-this.rotationCenter.y;
      z = points[i].z-this.rotationCenter.z;

      // rotation around x
      xy = this.cx*y - this.sx*z;
      xz = this.sx*y + this.cx*z;
      // rotation around y
      yz = this.cy*xz - this.sy*x;
      yx = this.sy*xz + this.cy*x;
      // rotation around z
      zx = this.cz*yx - this.sz*xy;
      zy = this.sz*yx + this.cz*xy;

      scaleFactor = camera.focalLength/(camera.focalLength + yz);
      x = zx*scaleFactor+this.rotationCenter.x;
      y = zy*scaleFactor+this.rotationCenter.y;
      z = yz+this.rotationCenter.z;
      obj.set2DPoint(i, x, y, -z, scaleFactor);
    }
  };

  this.renderCamera = function (camera){
    var obj = null
    for(var i = 0 ; i< this.sceneItems.length; i++){
      obj = this.sceneItems[i];
      obj.computeGeometry();
      this.Transform3DPointsTo2DPoints(obj, camera);
      this.sceneItems[i].draw();
    }
  };
};