var SinCosLUT = function(){

  this.SC_PRECISION = 0.25;
  this.SC_INV_PREC = 1.0 / this.SC_PRECISION;
  this.SC_PERIOD = 360 * this.SC_INV_PREC;
  this.sinLUT = []
  this.cosLUT = [];
  this.DEG_TO_RAD = Math.PI / 180.0 * this.SC_PRECISION;
  this.RAD_TO_DEG = 180.0 / Math.PI / this.SC_PRECISION;
  this.TWO_PI = Math.PI*2;

  this.init = function() {
    for (var i = 0; i < this.SC_PERIOD; i++) {
      this.sinLUT.push(Math.sin(i * this.DEG_TO_RAD));
      this.cosLUT.push(Math.cos(i * this.DEG_TO_RAD));
    }
  }

  this.sin = function(theta) {
    while (theta < 0) {
      theta += this.TWO_PI;
    }
    return this.sinLUT[Math.floor(theta * this.RAD_TO_DEG % this.SC_PERIOD)];
  }

  this.cos = function(theta) {
    while (theta < 0) {
      theta += this.TWO_PI;
    }
    return this.cosLUT[Math.floor(theta * this.RAD_TO_DEG % this.SC_PERIOD)];
  }

}