//// Superformula ----------------------------------------------
var Superformula = function (_cxt, size){
  this.cxt = _cxt;
  if (size === undefined){
    size = 10;
  }
  this.x = this.cxt.canvas.width/2;
  this.y = this.cxt.canvas.height/2;
  this.z = 0;

  //hack to be sure that points are loaded before linking them
  //	if(this.pointsArray3D.length == 8){
  //		this.addEdge(0, 1);
  //		this.addEdge(1, 2);
  //		this.addEdge(2, 3);
  //		this.addEdge(3, 0);
  //		this.addEdge(0, 4);
  //		this.addEdge(1, 5);
  //		this.addEdge(2, 6);
  //		this.addEdge(3, 7);
  //		this.addEdge(4, 5);
  //		this.addEdge(5, 6);
  //		this.addEdge(6, 7);
  //		this.addEdge(7, 4);
  //	}

  ////formula vars
  this.m = 1;
  this.n1 = 1;
  this.n2 = 1;
  this.n3 = 1;
  this.a = 1;
  this.b = 1;
  ////transformation vars, one min/max/transition for each var
  //one counter for each var
  var sinCounters = [];
  for (var i = 0; i < 8; i++) {
    sinCounters.push(new SinCounter(0.001 * (i + 1), 10, 11));
  }
  ////geometry vars
  //resolution
  var thetaSteps = 30;
  var thetaStepSize = Math.PI*2/(thetaSteps-1);
  var phiSteps = 20;
  var phiStepSize = Math.PI/(phiSteps-1);
  //temp variable for the biggest radius
  var r1Max = 0;
  var r2Max = 0;
  //array of radii
  var r1 = [];
  var r2 = [];
  //max radiux of the complete shape
  var radius = 10;
  ////motion vars
  this.centerX = 150;
  this.centerY = 150;
  this.rotationAngle = 0;

  ////set vars from outside (unused)
  this.setVars = function(shapeVars){
    this.shapeVars = shapeVars;
  }

  ////set rotation from outside (unused)
  this.setRotation = function(theta){
    this.rotationAngle = theta;
  }

  ////compute Superformula
  this.computeGeometry = function(){
    //->must have two sets of vars
    for (var i = 0; i < sinCounters.length; i++) {
      sinCounters[i].step();
    }
    this.m = sinCounters[0].getCount();
    this.n1 = sinCounters[1].getCount();
    this.n2 = sinCounters[2].getCount();
    this.n3 = sinCounters[3].getCount();
    this.a = 1;
    this.b = 1;

    ////compute the first 2D shape
    //for each theta step, compute a radius
    r1Max = 0;
    for(i=0; i<thetaSteps; i++){
      var theta = i * thetaStepSize - (Math.PI);
      var t1 = Math.cos(this.m * theta / 4) / this.a;
      t1 = Math.abs(t1);
      t1 = Math.pow(t1, this.n2);
      var t2 = Math.sin(this.m * theta / 4) / this.b;
      t2 = Math.abs(t2);
      t2 = Math.pow(t2,this.n3);
      //put the radius in the array
      r1[i] = Math.pow(Math.abs(t1+t2),-1/this.n1);
      //find the biggest radius
      if(r1[i] > r1Max){
        r1Max = r1[i];
      }
    }

    this.m = sinCounters[4].getCount();
    this.n1 = sinCounters[5].getCount();
    this.n2 = sinCounters[6].getCount();
    this.n3 = sinCounters[7].getCount();

    ////compute the second 2D shape
    //for each phi step, compute a radius
    r2Max = 0;
    for(i=0; i<phiSteps; i++){
      var phi = i * phiStepSize - (Math.PI / 2);
      t1 = Math.cos(this.m * phi / 4) / this.a;
      t1 = Math.abs(t1);
      t1 = Math.pow(t1, this.n2);
      t2 = Math.sin(this.m * phi / 4) / this.b;
      t2 = Math.abs(t2);
      t2 = Math.pow(t2,this.n3);
      //put the radius in the array
      r2[i] = Math.pow(Math.abs(t1+t2),-1/this.n1);
      //find the biggest radius
      if(r2[i] > r2Max){
        r2Max = r2[i];
      }
    }

    ///compute the spherical product of the two 2D shapes
    this.pointsArray3D = [];
    var count = 0;
    var x, y, z;
    var r1Norm, r2Norm;
    for (i=0; i<phiSteps; i++) {
      r2Norm = (r2[i] / (r2Max+0.01))*radius;
      for (var j = 0; j < thetaSteps; j++) {
        phi = i * phiStepSize - (Math.PI / 2);
        theta = j * thetaStepSize - (Math.PI);
        r1Norm = (r1[j] / (r1Max+0.01))*radius;       
        x = r1Norm * Math.cos(theta) * r2Norm * Math.cos(phi);
        y = r1Norm * Math.sin(theta) * r2Norm * Math.cos(phi);
        //z = Math.max(1, r2[i] * Math.sin(phi) * radius);
        z = r2Norm * Math.sin(phi) * radius;
        this.add3DPoint(x, y, z);
        count++;
      }
    }

  }

}

Superformula.prototype = new Object3D();

//->can be optimized with look-up tables
var polarToCartX = function(r, thetaRad, centerX){
  return r*Math.cos(thetaRad)+centerX;
}
var polarToCartY = function(r, thetaRad, centerY){
  return r*Math.sin(thetaRad)+centerY;
}
var polarDegToCartX = function(r, thetaDeg, centerX){
  return r*Math.cos(degToRad(thetaDeg))+centerX;
}
var polarDegToCartY = function(r, thetaDeg, centerY){
  return r*Math.sin(degToRad(thetaDeg))+centerY;
}
var degToRad = function(deg){
  //put north as the 0
  return deg*(Math.PI/180)+Math.PI*1.5;
}

var SinCounter = function(_freq, _amp, _offset) {
  this.freq = _freq;
  this.amp = _amp;
  this.offset = _offset;
  this.counter = 0;

  this.step = function(){
    this.counter += this.freq;
  }

  this.getCount = function() {
    return Math.sin(this.counter)*this.amp+this.offset;
  }
}


